Skip to content
Start here

Generate Pre Shared Key (PSK) for IPsec tunnels

magic_transit.ipsec_tunnels.psk_generate(stripsec_tunnel_id, IPSECTunnelPSKGenerateParams**kwargs) -> IPSECTunnelPSKGenerateResponse
POST/accounts/{account_id}/magic/ipsec_tunnels/{ipsec_tunnel_id}/psk_generate

Generates a Pre Shared Key for a specific IPsec tunnel used in the IKE session. Use ?validate_only=true as an optional query parameter to only run validation without persisting changes. After a PSK is generated, the PSK is immediately persisted to Cloudflare's edge and cannot be retrieved later. Note the PSK in a safe place.

Security
API Token

The preferred authorization scheme for interacting with the Cloudflare API. Create a token.

Example:Authorization: Bearer Sn3lZJTBX6kkg7OdcBUAxOO963GEIyGQqnFTOFYY
API Email + API Key

The previous authorization scheme for interacting with the Cloudflare API, used in conjunction with a Global API key.

Example:X-Auth-Email: user@example.com

The previous authorization scheme for interacting with the Cloudflare API. When possible, use API tokens instead of Global API keys.

Example:X-Auth-Key: 144c9defac04969c7bfad8efaa8ea194
Accepted Permissions (at least one required)
Magic WAN WriteMagic Transit Write
ParametersExpand Collapse
account_id: str

Identifier

maxLength32
ipsec_tunnel_id: str

Identifier

maxLength32
body: object
ReturnsExpand Collapse
class IPSECTunnelPSKGenerateResponse:
ipsec_tunnel_id: Optional[str]

Identifier

maxLength32
psk: Optional[str]

A randomly generated or provided string for use in the IPsec tunnel.

psk_metadata: Optional[PSKMetadata]

The PSK metadata that includes when the PSK was generated.

last_generated_on: Optional[datetime]

The date and time the tunnel was last modified.

formatdate-time

Generate Pre Shared Key (PSK) for IPsec tunnels

import os
from cloudflare import Cloudflare

client = Cloudflare(
    api_token=os.environ.get("CLOUDFLARE_API_TOKEN"),  # This is the default and can be omitted
)
response = client.magic_transit.ipsec_tunnels.psk_generate(
    ipsec_tunnel_id="023e105f4ecef8ad9ca31a8372d0c353",
    account_id="023e105f4ecef8ad9ca31a8372d0c353",
    body={},
)
print(response.ipsec_tunnel_id)
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "ipsec_tunnel_id": "023e105f4ecef8ad9ca31a8372d0c353",
    "psk": "O3bwKSjnaoCxDoUxjcq4Rk8ZKkezQUiy",
    "psk_metadata": {
      "last_generated_on": "2017-06-14T05:20:00Z"
    }
  },
  "success": true
}
Returns Examples
{
  "errors": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "messages": [
    {
      "code": 1000,
      "message": "message",
      "documentation_url": "documentation_url",
      "source": {
        "pointer": "pointer"
      }
    }
  ],
  "result": {
    "ipsec_tunnel_id": "023e105f4ecef8ad9ca31a8372d0c353",
    "psk": "O3bwKSjnaoCxDoUxjcq4Rk8ZKkezQUiy",
    "psk_metadata": {
      "last_generated_on": "2017-06-14T05:20:00Z"
    }
  },
  "success": true
}